(*
  Copyright (C) BitBlaze, 2009-2010. 

#Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.

#THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*)
type ctx
type revctx

val typ_to_stp : Stpvc.vc -> Vine.typ -> Stpvc.typ
val empty_ctx : unit -> ctx
val new_ctx : Stpvc.vc -> Vine.decl list -> ctx
val rev_ctx : ctx -> revctx
val vine_to_stp : Stpvc.vc -> ctx -> Vine.exp -> Stpvc.exp
val stp_to_type : Stpvc.exp -> Vine.typ
val stp_to_vine : ?strip_nums:bool -> ?ctx:revctx -> Stpvc.exp -> Vine.exp

val vc_simplify : Stpvc.vc -> ctx -> Vine.exp -> Vine.exp
